# Mastering Bitcoin: Programming the Open Blockchain (3rd Edition)

_By Andreas M. Antonopoulos and David A. Harding_

## [Preface](preface.adoc)
## [Chapter 1 - Introduction](ch01_intro.adoc)
## [Chapter 2 - Overview](ch02_overview.adoc)
## [Chapter 3 - Bitcoin Core](ch03_bitcoin-core.adoc)
## [Chapter 4 - Keys and Addresses](ch04_keys.adoc)
## [Chapter 5 - Wallets](ch05_wallets.adoc)
## [Chapter 6 - Transactions](ch06_transactions.adoc)
## [Chapter 7 - Authorization and Authentication](ch07_authorization-authentication.adoc)
## [Chapter 8 - Signatures](ch08_signatures.adoc)
## [Chapter 9 - Transaction Fees](ch09_fees.adoc)
## [Chapter 10 - Bitcoin Network](ch10_network.adoc)
## [Chapter 11 - Bitcoin Blockchain](ch11_blockchain.adoc)
## [Chapter 12 - Mining](ch12_mining.adoc)
## [Chapter 13 - Security](ch13_security.adoc)
## [Chapter 14 - Applications](ch14_applications.adoc)
## [Appendix A - The Bitcoin Whitepaper](appa_whitepaper.adoc)
## [Appendix B - Errata](appb_errata.adoc)
## [Appendix C - BIPS](appc_bips.adoc)